<template>
  <div class="col-md-6">
    <form
      id="resetPasswordForm"
      novalidate="novalidate"
    >
      <div
        v-if="passwordCodeSent===true"
        class="form-group"
      >
        <label for="code">Code&nbsp;:</label>
        <input
          id="code"
          v-model="code"
          name="code"
          type="text"
          class="form-control"
          required="required"
        >
      </div>
      <div
        v-if="passwordCodeSent===true&&isCodeValid===true"
        class="form-group"
      >
        <label for="password">Nouveau mot de passe&nbsp;:</label>
        <p>Une lettre miniscule, une lettre majuscule, un chiffre et un caractère spécial sont requis.</p>
        <p>Votre mot de passe doit faire au moins 12 caractères.</p>
        <div class="input-group">
          <input
            id="password"
            v-model="password"
            name="password"
            :type="passwordVisibility"
            class="form-control"
            autocomplete="off"
            required="required"
          >
          <span class="input-group-btn">
            <button
              class="btn btn-default"
              type="button"
              @mousedown="showPassword"
              @mouseup="hidePassword"
            ><span class="fa fa-eye" /></button>
          </span>
        </div>
      </div>
      <div
        v-if="passwordCodeSent===true&&isCodeValid===true"
        class="form-group"
      >
        <label for="passwordConfirm">Confirmation de mot de passe&nbsp;:</label>
        <div class="input-group">
          <input
            id="passwordConfirm"
            v-model="passwordConfirm"
            name="passwordConfirm"
            :type="passwordVisibility"
            class="form-control"
            autocomplete="off"
            required="required"
          >
          <span class="input-group-btn">
            <button
              class="btn btn-default"
              type="button"
              @mousedown="showPassword"
              @mouseup="hidePassword"
            ><span class="fa fa-eye" /></button>
          </span>
        </div>
      </div>
      <div
        class="form-group btn-list"
      >
        <click-button
          :disabled="isPasswordFormSubmitDisabled"
          @click="processPassword()"
        >
          <template slot="content">
            {{ passwordFormSubmitLabel }}
          </template>
        </click-button>
      </div>
    </form>
  </div>
</template>

<script>
import {mapActions, mapGetters} from "vuex";
import VanillaToasts from "vanillatoasts";
import ClickButton from "../../../../components/Button/ClickButton";

export default {
  name: "ProfilePassword",
  components: {ClickButton},
  data() {
    return {
      passwordHidden: true,
      passwordFormvalidator: null,
      code: '',
      password: '',
      passwordConfirm: '',
      checkPasswordResetSuccess: false
    }
  },
  computed: {
    ...mapGetters([
      'user',
      'profile',
      'isLoading',
      'passwordCodeSent',
      'isCodeValid',
      'isBusiness'
    ]),
    passwordVisibility() {
      return (this.passwordHidden) ? 'password' : 'text'
    },
    isPasswordFormSubmitDisabled () {
      if(this.passwordCodeSent===true&&this.isCodeValid===true) {
        return this.isLoading
            || this.code.length===0
            || this.password.length===0
            || this.passwordConfirm.length===0
            || this.password !== this.passwordConfirm
      } else if(this.passwordCodeSent===true) {
        return this.isLoading || this.code.length===0
      }else {
        return false
      }
    },
    passwordFormSubmitLabel() {
      if(this.passwordCodeSent===true&&this.isCodeValid===true) {
        return 'Valider mon changement'
      }else if(this.passwordCodeSent) {
        return 'Vérifier mon code'
      }else {
        return 'Modifier mon mot de passe'
      }
    }
  },
  mounted() {
    this.passwordFormvalidator = $('#resetPasswordForm').submit(function(e) {
      e.preventDefault();
    }).validate({
      rules: {
        code: {
          required: true,
        },
        password: {
          complexPassword: true
        },
        passwordConfirm: {
          required: true,
          minlength: 12,
          equalTo: '#password'
        },
      },
      errorElement: 'em',
      errorPlacement: function (error, element) {
        // Add the `help-block` class to the error element
        error.addClass("help-block");
        if(element[0]['name']=== "password" || element[0]['name']=== "passwordConfirm") {
          error.insertAfter(element[0]['parentElement'])
        }else if (element.prop("type") === "checkbox") {
          error.insertAfter(element.parent("label"));
        } else {
          error.insertAfter(element);
        }
      },
      highlight: function (element) {
        $(element).parents(".form-group").addClass("has-error").removeClass("has-success");
      },
      unhighlight: function (element) {
        $(element).parents(".form-group").addClass("has-success").removeClass("has-error");
      }
    });
  },
  methods: {
    ...mapActions([
      'passwordUserCode',
      'checkUserCode',
      'changeUserPassword',
      'loadingStarts',
      'loadingEnds'
    ]),
    processPassword() {
      if($("#resetPasswordForm").valid()) {
        this.loadingStarts()
        if (this.passwordCodeSent === true && this.isCodeValid === true) {
          this.change()
        } else if (this.passwordCodeSent) {
          this.check()
        } else {
          this.sendPasswordResetCode()
        }
      }
    },
    sendPasswordResetCode () {
      this.passwordUserCode()
        .then(
          () => {
            VanillaToasts.create({
              title: 'Mot de passe',
              text: 'Un code de vérification a été envoyé sur votre addresse email.',
              type: 'success',
              timeout: 10000, // hide after 5000ms, // optional paremter
            });
            this.loadingEnds();
          }
        )
    },
    check() {
      this.checkUserCode(this.code).then(
        () => {
          VanillaToasts.create({
            title: 'Mot de passe',
            text: 'Code valide. Vous pouvez modifier votre mot de passe.',
            type: 'success',
            timeout: 5000, // hide after 5000ms, // optional paremter
          });
          this.loadingEnds();
        }
      )
    },
    change() {
      this.changeUserPassword({
        code: this.code,
        password: this.password,
        passwordConfirm: this.passwordConfirm
      }).then(
        () => {
          VanillaToasts.create({
            title: 'Mot de passe',
            text: 'Votre mot de passe a été modifié avec succès.',
            type: 'success',
            timeout: 5000, // hide after 5000ms, // optional paremter
          });
          this.loadingEnds();
        }
      )
    },
    hidePassword() {
      this.passwordHidden = true
    },
    showPassword() {
      this.passwordHidden = false
    }
  }
}
</script>

<style scoped>

</style>